﻿Ext.require('App.Const.Finances');
Ext.define('App.Control.Kivii.Finances.SettlementDetail.Form', {
    extend: 'System.Control.EntityForm',
    xtype: 'App.Control.Kivii.Finances.SettlementDetail.Form',
    entityType: 'Kivii.Finances.Entities.SettlementDetail',
    scrollable: true,
    layout: {
        type: 'responsivecolumn',
        states: {
            small: 600,
            large: 0
        }
    },
    title: '结算明细',
    iconCls: 'x-fa fa-linode',
    viewModel: {
        data: {
            ButtonText: '添加',
            ButtonIcon: 'x-fa fa-linode',
            owner: {},
            entity: {
                Metadata: {},
                Kvid: null,
                Amount: 0,
                AmountPlan: 0,
                Currency: 'CNY'
            }
        },
        formulas: {
            amountChineseBig: function(get) {
                let _amount = get('entity.Amount');
                return KiviiContext.Const.FinancesFunctionsMoneyToChineseBig(_amount);
            },
            amount:{
            	get:function(_get){
            		let _amount = _get('entity.Amount');
            		return _amount;
            	},
            	set:function(_value){
            		let _amountPlan = this.data.entity.AmountPlan;
            	if(_value>_amountPlan)this.set('entity.AmountPlan',_value);
            	this.set('entity.Amount',_value);
            	}
            }
        }
    },
    dockedItems: [{
        xtype: 'toolbar',
        dock: 'top',
        overflowHandler: 'menu',
        items: [{
            margin: '0 3 -10 3',
            xtype: 'displayfield',
            bind: {
                value: '<div style="color:#FFA500">所属业务:{owner.BizId}</div>'
            },
            fieldStyle: {
                fontSize: '20px'
            }

        }, '->', {
            iconAlign: 'left',
            handler: '_onAddEntity',
            bind: {
                text: '{ButtonText}',
                iconCls: '{ButtonIcon}',
                disabled: '{!formIsValid}'
            }
        }]
    }],
    defaults: {
        xtype: 'textfield',
        labelWidth: 60,
        labelAlign: 'right',
        responsiveCls: 'big-50 small-100',
    },
    items: [{
        fieldLabel: '条目名称',
        responsiveCls: 'big-40 small-100',
        allowBlank: false,
        bind: '{entity.GoodsFullName}'
    }, {
        xtype: 'categoryField',
        fieldLabel: '条目类型',
        allowBlank: false,
        entityType: 'Kivii.Finances.Entities.Settlement',
        responsiveCls: 'big-30 small-100',
        internalCode: 'DetailType',
        readOnly: false,
        bind: {
            value: '{entity.Type}'
        }
    }, {
        fieldLabel: '条目编号',
        responsiveCls: 'big-30 small-100',
        bind: '{entity.GoodsId}'
    }, {
        xtype: 'numberfield',
        fieldLabel: '条目原价',
        hideTrigger: true,
        minValue: 0,
        responsiveCls: 'big-20 small-100',
        step: 0.1,
        allowBlank: false,
        // readOnly: true,
        bind: {
            value: '{entity.AmountPlan}'
        }
    }, {
        xtype: 'numberfield',
        fieldLabel: '折&nbsp;&nbsp;后&nbsp;价',
        hideTrigger: true,
        // minValue: 0,
        responsiveCls: 'big-20 small-100',
        step: 0.1,
        allowBlank: false,
        // readOnly: true,
        bind: {
            value: '{amount}'
        }
    }, {
        xtype: 'numberfield',
        fieldLabel: '数&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;量',
        hideTrigger: true,
        minValue: 0,
        responsiveCls: 'big-30 small-100',
        step: 0.1,
        allowBlank: false,
        // readOnly: true,
        bind: {
            value: '{entity.Quantity}'
        }
    }, {
        xtype: 'categoryField',
        fieldLabel: '数量单位',
        allowBlank: false,
        entityType: 'Kivii.Finances.Entities.Settlement',
        responsiveCls: 'big-30 small-100',
        internalCode: 'QuantityUnit',
        readOnly: false,
        bind: {
            value: '{entity.QuantityUnit}'
        }
    }, {
        responsiveCls: 'big-40 small-100',
        fieldLabel: '金额大写',
        readOnly: true,
        bind: {
            value: '{amountChineseBig}'
        }
    }, {
        fieldLabel: '型&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;号',
        responsiveCls: 'big-30 small-100',
        bind: '{entity.GoodsModel}'
    }, {
        fieldLabel: '规&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;格',
        responsiveCls: 'big-30 small-100',
        bind: '{entity.GoodsSpecifications}'
    }, {
        xtype: 'textarea',
        fieldLabel: '备&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;注',
        responsiveCls: 'big-100 small-100',
        bind: '{entity.Remark}'
    }],
    setOwner: function(_entity, _owner, _ctrl) {
        let _view = this;
        let _vm = _view.getViewModel();
        let _current = {};
        Ext.apply(_current, _entity);
        _vm.set('entity', _current);
        _vm.set('owner', _owner);
        _vm.set('ButtonText', _ctrl.text);
        _vm.set('ButtonIcon', _ctrl.iconCls);
    },
    controller: {
        _onAddEntity: function(_ctrl) {
            let _controller = this;
            let _vm = _controller.getViewModel();
            let _view = _controller.getView();
            _view.fireEvent('entityAdd', _view, _vm.data.entity);
            // _vm.set('entity', {
            //          Metadata: {},
            //          Kvid: null,
            //          Amount: 0,
            //          AmountPlan: 0,
            //          Currency: 'CNY'
            //      });
        }
    }
});