﻿using Kivii.Finances.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Kivii.Finances.Extensions
{
    public static class PolicyExtension
    {
        public static PolicyRecord Offset(this PolicyRecord policyRecord, string remark)
        {
            policyRecord.ThrowIfNull("政策执行记录不能为空!");
            (policyRecord.OffsetKvid != Guid.Empty).ThrowIfTrue("已冲账,无需重复操作");

            #region policyRecord冲账
            var newPolicyRecordKvid = Guid.NewGuid();
            policyRecord.OffsetKvid = newPolicyRecordKvid;
            policyRecord.AddOnlyProperties(o => o.OffsetKvid);
            policyRecord.Remark = $"{remark}";
            policyRecord.AddOnlyProperties(o => o.Remark);

            //新建一个和原来一样的
            var offsetPolicyRecord = new PolicyRecord();
            offsetPolicyRecord.PopulateWith(policyRecord);
            offsetPolicyRecord.OffsetKvid = policyRecord.Kvid;//新的冲帐关联用原来的Kvid
            offsetPolicyRecord.Kvid = newPolicyRecordKvid;
            offsetPolicyRecord.Remark = $"{remark}";
            offsetPolicyRecord.AmountPlan = 0 - offsetPolicyRecord.AmountPlan;
            offsetPolicyRecord.AmountOrigin = 0 - offsetPolicyRecord.AmountOrigin;
            offsetPolicyRecord.AmountPolicy = 0 - offsetPolicyRecord.AmountPolicy;
            offsetPolicyRecord.Amount = 0 - offsetPolicyRecord.Amount;//反向值
            offsetPolicyRecord.OperatorName = KiviiContext.CurrentMember.FullName;
            offsetPolicyRecord.OperatorKvid = KiviiContext.CurrentMember.Kvid;
            offsetPolicyRecord.OperateTime = DateTime.Now;
            #endregion

            return offsetPolicyRecord;
        }
    }
}
